#include <iostream>
#include "stackdyn.hpp"

using namespace std;

#define INC_SIZE 5

Stack::Stack() : top(0), cursize(INC_SIZE)
{
    array = new int[INC_SIZE];
}

Stack::~Stack()
{
    delete array;
}

void Stack::push(int elem)
{
    if (top >= cursize) {
        int i;
        int *temp = new int[cursize + INC_SIZE];
        for (i=0; i<top; i++) temp[i] = array[i];
        delete array;
        array = temp;
        cursize += INC_SIZE;
    }
    array[top++] = elem;
}

int Stack::pop()
{
    if (top > 0) return array[--top];
    else cerr << "Stack::pop() : is empty" << endl;          
}

int Stack::query()
{
    if (top > 0) return array[top-1];
    else cerr << "Stack::top() : is empty" << endl;
}

void Stack::print()
{
    int i;
    cout << "[";
    for (i=0; i<top; i++) cout << array[i] << ",";
    cout << "]" << endl;
}
